/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package DAO;

import org.hibernate.*;
import org.hibernate.cfg.Configuration;
import java.util.*;
import java.sql.*;
import org.hibernate.exception.ConstraintViolationException;

/**
 *
 * @author faycal
 */
public class MagasinHelper {

    Session session = null;

    public List<String> getColonnes() {
        return colonnes;
    }
    ArrayList<String> colonnes = new ArrayList();

    public MagasinHelper() {
        this.session = HibernateUtil.getSessionFactory().openSession();
    }

    public List getProductsColums() {
        List<Product> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select p.productId, p.manufacturerId, p.productCode, p.purchaseCost, p.quantityOnHand, p.markup, p.available, p.description from Product p");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List<Product> getProducts() {
        List<Product> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from Product p");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public Product getProduct(int id) {
        Product resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from Product p where p.productId = :_id");
            q.setInteger("_id", id);
            resultat = (Product) q.list().iterator().next();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getClientsColums() {
        List<Customer> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select a.customerId, a.name, a.addressline1,a.addressline2,a.zip,b.rate from Customer a, DiscountCode b where a.discountCode=b.discountCode");
            //Query q=session.createQuery("from Customer");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List<Customer> getClients() {
        List<Customer> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from Customer c");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getClientsColums(String name) {
        List resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select a.customerId, a.name, a.addressline1,a.addressline2,a.zip,b.rate from Customer a, DiscountCode b where a.discountCode=b.discountCode and a.name like :_name");
            //Query q=session.createQuery("from Customer");
            q.setString("_name", name);
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getClientsColums(int _id) {
        List resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select a.customerId, a.name, a.addressline1,a.addressline2,a.zip from Customer a where a.customerId = :_id");
            q.setInteger("_id", _id);
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getManufacturers() {
        List<Manufacturer> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from Manufacturer m");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getProductCodesColums() {
        List<ProductCode> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select p.prodCode, p.discountCode, p.description from ProductCode p");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getProductCodes() {
        List<ProductCode> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from ProductCode p");
            resultat = q.list();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public ProductCode getProductCode(String id) {
        ProductCode resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from ProductCode p where p.prodCode = :_id");
            q.setString("_id", id);
            resultat = (ProductCode) q.list().iterator().next();

        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List getDiscountCodesColums() {
        List resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select dc.discountCode, dc.rate from DiscountCode dc");
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }

        }

        return resultat;

    }

    public List getDiscountCodes() {
        List resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from DiscountCode dc");
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }

        }

        return resultat;

    }

    public DiscountCode getDiscountCode(char c) {
        DiscountCode resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from DiscountCode dc where dc.discountCode = :_id");
            q.setCharacter("_id", c);
            resultat = (DiscountCode) q.list().iterator().next();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }

        }

        return resultat;

    }

    public List getMicroMarket() {
        List<MicroMarket> resultat = null;
        Transaction tx = null;
        try {
            //if(!session.isOpen())
            session = HibernateUtil.getSessionFactory().openSession();
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("from MicroMarket");
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }

        }
        return resultat;
    }

    public List getZipCode() {
        List resultat = null;
        Transaction tx = null;
        try {
            //if(!session.isOpen())
            session = HibernateUtil.getSessionFactory().openSession();
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select a.zipCode from MicroMarket a");
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }

        }
        return resultat;
    }

    public void add(Object data) {
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            session.save(data);
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public void update(Object data) {

        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            session.update(data);
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public Customer getClient(int id) {

        Customer client = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();
            tx = session.beginTransaction();
            Query q = session.createQuery(" from Customer a  where a.customerId =:_id");
            q.setInteger("_id", id);
            client = (Customer) q.list().iterator().next();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return client;
    }

    public void deleteCustomer(int _id) {

        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from PurchaseOrder po  where po.customerId =:_id");
            q.setInteger("_id", _id);
            for (Object po : q.list()) {
                session.delete((PurchaseOrder) po);
            }
            q = session.createQuery(" from Customer a  where a.customerId =:_id");
            q.setInteger("_id", _id);
            session.delete((Customer) q.list().iterator().next());
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public void deleteProduct(int _id) {

        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from Product a  where a.productId =:_id");
            q.setInteger("_id", _id);
            session.delete((Product) q.list().iterator().next());
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public void deletePurchase(int _id) {

        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from PurchaseOrder a  where a.orderNum =:_id");
            q.setInteger("_id", _id);
            session.delete((PurchaseOrder) q.list().iterator().next());
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public void deleteDiscountCode(char _id) {

        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from DiscountCode a  where a.discountCode =:_id");
            q.setCharacter("_id", _id);
            session.delete((DiscountCode) q.list().iterator().next());
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public void deleteProductCode(String _id) {

        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from ProductCode a  where a.prodCode =:_id");
            q.setString("_id", _id);
            session.delete((ProductCode) q.list().iterator().next());
            tx.commit();
        } catch (Exception e) {
            e.printStackTrace();
            tx.rollback();
            throw e;
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

    }

    public List getPurchaseColums() {
        List resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select po.orderNum, po.customerId, po.productId, po.quantity, po.shippingCost, po.salesDate, po.shippingDate, po.freightCompany from PurchaseOrder po");
            resultat = (List<PurchaseOrder>) q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public PurchaseOrder getPurchase(int id) {
        PurchaseOrder resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from PurchaseOrder p where p.orderNum = :_id");
            q.setInteger("_id", id);
            resultat = (PurchaseOrder) q.list().iterator().next();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public List<PurchaseOrder> getPurchases(int id) {
        List<PurchaseOrder> resultat = null;
        Transaction tx = null;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery(" from PurchaseOrder po where po.customerId = :_id");
            q.setInteger("_id", id);
            resultat = q.list();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;
    }

    public int getMaxId() {
        Transaction tx = null;
        int resultat = -1;
        try {
            if (!session.isOpen()) {
                session = HibernateUtil.getSessionFactory().openSession();
            }
            session.flush();

            tx = session.beginTransaction();
            Query q = session.createQuery("select MAX(a.customerId) from Customer a");

            resultat = (int) q.list().iterator().next();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (session.isOpen()) {
                session.close();
            }
        }

        return resultat;

    }
}
